VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClassList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'   CLASS MODULE: SORTED LIST OF ITEMS

Public Largest As ClassItem

Public Inc As ClassCounters

'
'   true if positive element exists
'
Public Function Positive() As Boolean

    Inc.Decis
    If Largest Is Nothing Then
    
        Positive = False
        
    Else
    
        Inc.Decis
        Positive = (Largest.Cj > 0)
    
    End If

End Function

'
'   rebuild sorted list
'
Public Sub RebuildWith(tableau)
    
    Dim j As Long
    
    Dim tempItem1 As ClassItem
    
    Dim tempItem2 As ClassItem
    
    Dim tempCj As Double
    
    '   clean up
    Do While Not Largest Is Nothing
    
        RemoveLargest
    
        Inc.Loops
    Loop
    
    '   create sorted list
    Inc.Loops UBound(tableau, 2)
    For j = 1 To UBound(tableau, 2) - 1
            
        tempCj = tableau(UBound(tableau, 1), j)
        
        Inc.Decis
        If tempCj <> 0 Then
        
            Set tempItem1 = New ClassItem
            
            tempItem1.Define j, tempCj, Nothing
            
            Inc.Decis
            If Largest Is Nothing Then ' first occurance
                
                Set Largest = tempItem1
            
            Else
            
                Inc.Decis
                If Largest.Cj < tempItem1.Cj Then ' new largest
                    
                    Set tempItem1.NextInList = Largest
                    
                    Set Largest = tempItem1
                
                Else
                    
                    Set tempItem2 = Largest
                    
                    Do While True
                        
                        Inc.Loops
                        Inc.Decis
                        If tempItem2.NextInList Is Nothing Then ' the end of the row
                            
                            Set tempItem2.NextInList = tempItem1
                            
                            Exit Do
                        
                        Else
                        
                            Inc.Decis
                            If tempItem2.NextInList.Cj <= tempItem1.Cj Then ' fits right between
                                
                                Set tempItem1.NextInList = tempItem2.NextInList
                                
                                Set tempItem2.NextInList = tempItem1
                                
                                Exit Do
                            
                            Else
                            
                                Set tempItem2 = tempItem2.NextInList ' try with next in row
                            
                            End If
                        End If
                    Loop
                End If
            End If
        End If
    Next j
End Sub


'
'   remove the largest item in the list
'
Public Sub RemoveLargest()

    Dim tmpItem As ClassItem
    
    Set tmpItem = Largest.NextInList
    
    Set Largest = Nothing
    
    Set Largest = tmpItem
    
    Set tmpItem = Nothing

End Sub

'
'   test if list is empty
'
Public Function IsEmpty() As Boolean
    
    Inc.Decis
    IsEmpty = (Largest Is Nothing)

End Function

'
'   write sorted list to a file, for testing purposes only
'
Public Sub WriteListToFile(outputFile As String)

    Dim fileID As Long: fileID = OpenFile(outputFile, openForOutput)
    
    Dim msg As String
    
    Dim tmpItem As ClassItem
    
    Set tmpItem = Largest
    
    msg = NewLine("SORTED LIST ITEMS: ") & NewLine("")
    
    Do While Not tmpItem Is Nothing
    
        msg = msg & NewLine(tmpItem.j & ": " & tmpItem.Cj)
        
        Set tmpItem = tmpItem.NextInList
    
    Loop
    
    Print #fileID, msg

    Close #fileID

End Sub

'
'   return as string
'
Public Function ListAsString() As String

    Dim msg As String
    
    Dim tmpItem As ClassItem
    
    Set tmpItem = Largest
    
    msg = "SORTED LIST ITEMS: "
    
    Do While Not tmpItem Is Nothing
    
        msg = msg & tmpItem.Cj & "(j=" & tmpItem.j & ") -> "
        
        Set tmpItem = tmpItem.NextInList
    
    Loop
    
    ListAsString = msg

End Function

