VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form FormAnalysis 
   Caption         =   "Analysis: Methods Efficiency on Multiple Problems"
   ClientHeight    =   7575
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11085
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   7575
   ScaleWidth      =   11085
   WindowState     =   2  'Maximized
   Begin MSComDlg.CommonDialog cdlgExport 
      Left            =   300
      Top             =   1920
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin ProjectSixPap.MyGrid mgAnalysis 
      Height          =   975
      Left            =   180
      TabIndex        =   0
      Top             =   660
      Width           =   2835
      _extentx        =   5001
      _extenty        =   1720
   End
   Begin ProjectSixPap.MyCheckLabels mclMethods 
      Height          =   435
      Left            =   5280
      TabIndex        =   1
      Top             =   0
      Width           =   1215
      _extentx        =   2143
      _extenty        =   767
   End
   Begin ProjectSixPap.MyActiveLabels malAction 
      Height          =   435
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   5175
      _extentx        =   9128
      _extenty        =   767
   End
End
Attribute VB_Name = "FormAnalysis"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'   FORM ANALYSIS: COMPARING METHODS EFFICIENCY WITH MULTIPLE PROBLEMS

Public fieldSelectedProblem As ClassProblem

Private firstActivation As Boolean

Private problemCollection As New Collection

'
'   handle adding to collection and grid
'
Public Sub AddToProblemCollection(newDefinitionFile As String)

On Error GoTo errorAddToProblemCollection

    Dim addProblemCount As Long: addProblemCount = problemCollection.Count + 1

    Dim tempProblem As New ClassProblem: Set tempProblem = New ClassProblem
    
    tempProblem.InitialWithNoDisplay
            
    tempProblem.OpenProblem newDefinitionFile
            
    problemCollection.Add tempProblem, tempProblem.ProblemName
        
    mgAnalysis.SetHeaderRow Array(" "), addProblemCount
                
    tempProblem.DisplayInAnalysis mgAnalysis, addProblemCount
    
    mgAnalysis.ApplyCheck addProblemCount

    CheckProblemsCount

    Exit Sub

errorAddToProblemCollection:

    If Err.Number = 457 Then
    
        '   collection.add error: item (key) already exists
    
        MsgBox "Problem is already included in analysis" & _
                NewLine("Problem name: " & tempProblem.ProblemName), , _
                "ADD PROBLEM ERROR!"
        
        On Error Resume Next
    
    Else
    
        Err.Raise Err.Number, , "Add problem to collection. Problem name:" & NewProblemName & _
                                NewLine("File: " & newDefinitionFile) & _
                                NewLine(Err.Description)

    End If

End Sub

'
'   clear analysis grid
'
Public Sub ClearAnalysisEntries()

    Set problemCollection = Nothing
    Set problemCollection = New Collection
    
    mgAnalysis.SelectedRow = 0
    
    mgAnalysis.ClearValueRows

    CheckProblemsCount

End Sub

'
'   execute methods
'
Public Sub ExecuteWithCheckedProblems()

On Error GoTo errorExecuteWithCheckedProblems

    '   check for problem being edited
    If ProblemAnalysisRow(FormSingleProblem.CurrentProblem.ProblemName) > 0 Then
    
        If Not FormSingleProblem.TestCurrentForSave Then Exit Sub
    
    End If

    Dim tmpProblem As ClassProblem
    
    Screen.MousePointer = 11
    
    Dim tempMethod As EnumMethod
    
    Dim problemRow As Long
    For problemRow = 1 To mgAnalysis.ValueRowCount
    
        If mgAnalysis.IsChecked(problemRow) Then
    
            Set tmpProblem = problemCollection(mgAnalysis.GetCellValue(problemRow, 1))
    
            For tempMethod = PushPull To Simplex

                If mclMethods.CheckLabel(EnumMethodAsString(tempMethod)) Then

                    tmpProblem.Result(tempMethod).ResetToDefault
            
                    If tempMethod = PushPull Then ModulePushPull.ExecutePushPull tmpProblem
                    If tempMethod = Simplex Then ModuleSimplex.ExecuteSimplex tmpProblem
            
                    tmpProblem.DisplayInAnalysis mgAnalysis, problemRow
                
                End If
    
            Next tempMethod
    
            tmpProblem.SaveProblem
        
        End If
        
    Next problemRow
    
    If Not SelectedProblem Is Nothing Then ShowSelected SelectedProblem.ProblemName
    
    Screen.MousePointer = 0
    
    Exit Sub
    
errorExecuteWithCheckedProblems:

    Screen.MousePointer = 0

    MsgBox Err.Description, , "EXECUTE METHODS ERROR!"

End Sub


'
'   reset results for ticked methods and checked problems
'
Public Sub ResetResultsForCheckedProblems()

On Error GoTo errorResetResultsForCheckedProblems

    Dim tmpProblem As ClassProblem
    
    Screen.MousePointer = 11
    
    Dim tempMethod As EnumMethod
    
    Dim problemRow As Long
    For problemRow = 1 To mgAnalysis.ValueRowCount
    
        If mgAnalysis.IsChecked(problemRow) Then
    
            Set tmpProblem = problemCollection(mgAnalysis.GetCellValue(problemRow, 1))
    
            For tempMethod = PushPull To Simplex

                If mclMethods.CheckLabel(EnumMethodAsString(tempMethod)) Then

                    tmpProblem.Result(tempMethod).ResetToDefault
            
                    If Dir(tmpProblem.Result(tempMethod).DetailFile) <> "" Then _
                        Kill tmpProblem.Result(tempMethod).DetailFile
            
                    tmpProblem.DisplayInAnalysis mgAnalysis, problemRow
                
                End If
    
            Next tempMethod
    
            tmpProblem.SaveProblem
        
        End If
        
    Next problemRow
    
    If Not SelectedProblem Is Nothing Then ShowSelected SelectedProblem.ProblemName
    
    Screen.MousePointer = 0
    
    Exit Sub
    
errorResetResultsForCheckedProblems:

    Screen.MousePointer = 0

    MsgBox Err.Description, , "RESET RESULTS ERROR!"

End Sub

'
'   return problem from collection
'
Public Function ProblemInCollection(ProblemName As String) As ClassProblem

    Set ProblemInCollection = problemCollection(ProblemName)

End Function

'
'   remove selected problem
'
Public Sub RemoveSelectedProblem()

    If SelectedProblem Is Nothing Then Exit Sub

    Dim tempProblem As ClassProblem
    Set tempProblem = SelectedProblem

    mgAnalysis.SelectedRow = 0

    problemCollection.Remove tempProblem.ProblemName
    
    mgAnalysis.RemoveRow ProblemAnalysisRow(tempProblem.ProblemName)
'    mgAnalysis.RemoveRow mgAnalysis.SelectedRow
    
    Dim i As Long
    
    For i = 1 To mgAnalysis.ValueRowCount
    
        problemCollection(mgAnalysis.GetCellValue(i, 1)).AnalysisRowIndex = i
    
    Next i
    
'    Set SelectedProblem = Nothing

    CheckProblemsCount
    
End Sub



'
'   check if there are any problems in analysis
'
Private Sub CheckProblemsCount()

    Me.Caption = "Analysis: " & mgAnalysis.ValueRowCount & " problems included"


'    Dim tempEnabled As Boolean
'    tempEnabled = (mgAnalysis.ValueRowCount > 0)

'    malAction.LabelEnabled("CLEAR") = tempEnabled
'    malAction.LabelEnabled("REMOVE") = tempEnabled
'    malAction.LabelEnabled("EXPORT") = tempEnabled
'    malAction.LabelEnabled("EXECUTE") = tempEnabled
'
'    mclMethods.EnableAll tempEnabled

End Sub

'
'   property set selected problem
'
Public Property Set SelectedProblem(NewProblem As ClassProblem)

    Set fieldSelectedProblem = NewProblem

End Property

'
'   property get selected problem
'
Public Property Get SelectedProblem() As ClassProblem

    Set SelectedProblem = fieldSelectedProblem

End Property


'
'   set analysis grid headers, etc...
'
Private Sub SetAnalysisGrid()

    With mgAnalysis
    
        .CheckBoxed("Check All") = True
        
        .CanHideColumn = True
        
        .showSelectedRow = True
        
        .ToggleSelectedEnabled = False
        
        Dim titleMatrix(1, 0)
        titleMatrix(0, 0) = ""
        titleMatrix(1, 0) = ""
    
        .SetHeaderTitle titleMatrix
    
        .SetHeaderColumn Array("Definition", "Name"), 1
        .SetHeaderColumn Array("#-", "Objective")
        .SetHeaderColumn Array("#-", "m")
        .SetHeaderColumn Array("#-", "s")
        .SetHeaderColumn Array("#-", "Constraints")
        
        Dim method As EnumMethod
        
        For method = PushPull To Simplex
        
            .OtherData(EnumMethodAsString(method)) = .currentCol + 1
            
            .SetHeaderColumn Array(EnumMethodAsString(method), "Status")
            .SetHeaderColumn Array("#-", "Deg.")
            .SetHeaderColumn Array("#-", "Value")
            .SetHeaderColumn Array("#-", "BVS")
            .SetHeaderColumn Array("#-", EnumCounterAsStr(cntIterations, True))
            .SetHeaderColumn Array("#-", EnumCounterAsStr(cntAddSubs, True))
            .SetHeaderColumn Array("#-", EnumCounterAsStr(cntMultDivs, True))
            .SetHeaderColumn Array("#-", EnumCounterAsStr(cntLoops, True))
            .SetHeaderColumn Array("#-", EnumCounterAsStr(cntDecis, True))
        
        Next method
        
        .OtherData("last column") = .currentCol
        
        .fxgHandle.AllowUserResizing = flexResizeColumns
        
        .ClearValueRows
    
    End With

End Sub

'
'   examine if problem exists
'
Public Function ProblemAnalysisRow(ProblemName) As Long

    ProblemAnalysisRow = 0
    
    Dim i As Long
    For i = 1 To mgAnalysis.ValueRowCount
    
        If mgAnalysis.GetCellValue(i, 1) = ProblemName Then
            '   problem found
            ProblemAnalysisRow = i
            Exit For
        
        End If
    
    Next i
    
End Function

'
'   show as selected if exists
'
Public Function ShowSelected(ProblemName As String) As Boolean
    
    Dim tempAnalysisRow As Long: tempAnalysisRow = ProblemAnalysisRow(ProblemName)

    ShowSelected = (tempAnalysisRow > 0)

    mgAnalysis.SelectedRow(True) = tempAnalysisRow

End Function

'
'   activating
'
Private Sub Form_Activate()

    If firstActivation Then
    
        firstActivation = False

        SetAnalysisGrid
            
        CheckProblemsCount
    
    End If

End Sub

'
'   loading of a form
'
Private Sub Form_Load()

    firstActivation = True

    cdlgExport.InitDir = App.Path
    cdlgExport.CancelError = True

    '   initiate action labels (menu)
    Set malAction.HostForm1 = FormAnalysis
    Set malAction.HostForm2 = FormRepository
    Set malAction.HostForm3 = FormSingleProblem
    malAction.Direction = alHorizontal
    malAction.AddNew "CLEAR", "Clear", "Clear all problems form analysis list."
    malAction.AddNew "REMOVE", "Remove", "Remove selected problem from the list."
    malAction.AddNew "EXPORT", "Export Analysis", "Export analysis list (result) to TXT file."
'    malAction.AddNew "OPEN", "Open Analysis", "Open MS Excel file with exported analysis."
    malAction.AddNew "RESET", "Reset Results", "Reset results for ticked methods and checked problems."
    malAction.AddNew "EXECUTE", "Execute Algorithm:", "Execute ticked algorithms on checked problems."
    
    '   check boxes
    Set mclMethods.HostForm1 = FormAnalysis
    Set mclMethods.HostForm2 = FormRepository
    Set mclMethods.HostForm3 = FormSingleProblem
    mclMethods.Move malAction.Left + malAction.Width, 0 '_
                      '(malAction.Top + malAction.Height - mclMethods.Height) / 2
    mclMethods.AddNew EnumMethodAsString(PushPull), PascalType(EnumMethodAsString(PushPull)), _
                      "Select method to be executed.", , True
    mclMethods.AddNew EnumMethodAsString(Simplex), PascalType(EnumMethodAsString(Simplex)), _
                      "Select method to be executed.", , True
    
End Sub

'
'   before unloading: don't allow, just minimize
'
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    Cancel = 1
    
    Me.WindowState = 1

End Sub

'
'   Form Resize: stretch the grid over the whole form
'
Private Sub Form_Resize()
    
    If (Me.WindowState <> 1) And (FormMain.WindowState <> 1) Then
    
        With mgAnalysis
        
            If Me.ScaleWidth - 2 * .Left > 0 Then _
                .Width = Me.ScaleWidth - 2 * .Left
        
            If Me.ScaleHeight - .Left - .Top > 0 Then _
                .Height = Me.ScaleHeight - .Left - .Top
            
        End With
    
    End If

End Sub

'
'   execute action
'
Private Sub malAction_Action(ActionName As String)

    Select Case ActionName
    
    Case "CLEAR": ClearAnalysisEntries
    
    Case "EXPORT": DoExport
    
    Case "REMOVE": RemoveSelectedProblem
    
    Case "RESET": ResetResultsForCheckedProblems
    
    Case "EXECUTE": ExecuteWithCheckedProblems
    
    Case Else: MsgBox (ActionName)
    
    End Select

End Sub

'
'   export to selected file
'
Public Sub DoExport()

On Error GoTo errorDoExport

    cdlgExport.ShowSave
    
    mgAnalysis.ExportGrid cdlgExport.fileName

    Exit Sub
    
errorDoExport:

    Exit Sub
End Sub

'
'   selection happened
'
Public Sub mgAnalysis_ItemSelected(newSelectedRow As Long)

    If newSelectedRow = 0 Then
    
        Set SelectedProblem = Nothing
        
    Else
                   
        Dim tempProblemName As String
        tempProblemName = mgAnalysis.GetCellValue(newSelectedRow, 1)
                   
        Set SelectedProblem = problemCollection(tempProblemName)
        
        FormSingleProblem.OpenProblem tempProblemName

        FormRepository.mflvRepository.Locate tempProblemName
        
    End If
    
End Sub

'
'   Name has been changed
'
Public Sub ChangeProblemData(ProblemName As String, _
                             Optional NewProblemName As String = "")

    If NewProblemName = "" Then NewProblemName = ProblemName

    Dim tempAnalysisRow As Long
    tempAnalysisRow = ProblemAnalysisRow(ProblemName)
    If tempAnalysisRow = 0 Then Exit Sub
    
    problemCollection.Remove ProblemName

    Dim tempProblem As New ClassProblem: Set tempProblem = New ClassProblem
    tempProblem.InitialWithNoDisplay
    tempProblem.OpenProblem RepositoryFolder & "\" & NewProblemName & ".txt"
            
    problemCollection.Add tempProblem, tempProblem.ProblemName
        
    tempProblem.DisplayInAnalysis mgAnalysis, tempAnalysisRow
    
    ShowSelected tempProblem.ProblemName
    
    Set tempProblem = Nothing
    
End Sub
