VERSION 5.00
Begin VB.Form FormRepository 
   Caption         =   "Repository"
   ClientHeight    =   9450
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5160
   Icon            =   "FormRepository.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   9450
   ScaleWidth      =   5160
   Begin ProjectSixPap.MyFileListView mflvTrash 
      Height          =   2715
      Left            =   2700
      TabIndex        =   2
      Top             =   60
      Width           =   2115
      _extentx        =   3731
      _extenty        =   4789
   End
   Begin ProjectSixPap.MyFileListView mflvRepository 
      Height          =   6075
      Left            =   60
      TabIndex        =   1
      Top             =   2940
      Width           =   4875
      _extentx        =   8599
      _extenty        =   10716
   End
   Begin ProjectSixPap.MyActiveLabels malAction 
      Height          =   2775
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2475
      _extentx        =   4366
      _extenty        =   4895
   End
End
Attribute VB_Name = "FormRepository"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private firstActivation As Boolean

Public SignificantWidth As Long

Private IsNewProblem As Boolean

'
'   create a copy of a problem
'
Public Sub CreateCopy()

    If Not FormSingleProblem.TestCurrentForSave Then Exit Sub

    Dim originalItem As String
    originalItem = mflvRepository.SelectedItem
    If originalItem = "" Then Exit Sub
    
    Dim copyItem As String
    copyItem = GetCopyName(originalItem, mflvRepository)
    
    mflvRepository.Items.Add , , copyItem

    Dim sourceFile As String, targetFile As String
    
    '   copy definition file
    sourceFile = RepositoryFolder & "\" & originalItem & ".txt"
    targetFile = RepositoryFolder & "\" & copyItem & ".txt"
    If Dir(sourceFile) <> "" Then FileCopy sourceFile, targetFile
    
    '   copy result detail files
    sourceFile = RepositoryFolder & "\Solutions\" & originalItem & DetailFileExtension(PushPull)
    targetFile = RepositoryFolder & "\Solutions\" & copyItem & DetailFileExtension(PushPull)
    If Dir(sourceFile) <> "" Then FileCopy sourceFile, targetFile
    
    sourceFile = RepositoryFolder & "\" & originalItem & DetailFileExtension(Simplex)
    targetFile = RepositoryFolder & "\" & copyItem & DetailFileExtension(Simplex)
    If Dir(sourceFile) <> "" Then FileCopy sourceFile, targetFile
    
    '   locate new problem
    mflvRepository.Locate copyItem, True
    mflvRepository.ReArrange

    '   activate rename
    mflvRepository.StartEditing

End Sub

'
'   empty the trash bin
'
Public Sub EmptyTrashBin()

    If Not FormSingleProblem.TestCurrentForSave Then Exit Sub

    If MsgBox("All files in trash bin will be permanently deleted, proceed?", _
              vbExclamation + vbOKCancel, _
              "Emptying the Trash bin") = vbCancel Then Exit Sub

    Dim tempFile As String
    
    tempFile = Dir(TrashFolder & "\Solutions\*")
    Do While tempFile <> ""
    
        Kill TrashFolder & "\Solutions\" & tempFile
        tempFile = Dir()
        
    Loop

    tempFile = Dir(TrashFolder & "\*")
    Do While tempFile <> ""
    
        Kill TrashFolder & "\" & tempFile
        tempFile = Dir()
        
    Loop

    Dim tempItem As ListItem
    For Each tempItem In mflvTrash.Items
    
        tempItem.Selected = True
        
    Next tempItem
    
    mflvTrash.RemoveSelected

End Sub


'
'   execute add problems
'
Private Sub ExecuteIncludeProblems()
    
    If Not FormSingleProblem.TestCurrentForSave Then Exit Sub
    
On Error GoTo errorExecuteIncludeProblems
    
    Dim tempItemName As String: tempItemName = ""
    Dim tempItem As ListItem
    For Each tempItem In mflvRepository.Items
   
        If tempItem.Selected Then
        
            If FormAnalysis.ProblemAnalysisRow(tempItem.Text) = 0 Then
        
                FormAnalysis.AddToProblemCollection RepositoryFolder & _
                    "\" & tempItem.Text & ".txt"
        
                tempItemName = tempItem.Text
            
            End If
            
        End If
    
    Next tempItem
   
    If tempItemName <> "" Then mflvRepository_ItemClicked tempItemName
    
    Exit Sub
    
errorExecuteIncludeProblems:

    MsgBox Err.Description, , "ERROR ADDING PROBLEMS TO ANALYSIS!"

End Sub

'
'   create a new problem
'
Private Sub CreateNewProblem()

    Dim newName As String: newName = GetCopyName("NewProblem", mflvRepository)
    
    If Not FormSingleProblem.NewProblem(newName) Then Exit Sub
    
    mflvRepository.Items.Add , , newName
    
    mflvRepository.ReArrange
    
    mflvRepository.Locate newName
    
    IsNewProblem = True
    
    mflvRepository.StartEditing
    
    
'
'    mflvRepository.AddNewTemporary "NewProblem"
        
End Sub

'
'   get copy name for existing item
'
Private Function GetCopyName(ByVal itemName As String, _
                             FileListView As MyFileListView) As String

    Dim tempName As String: tempName = itemName
    
    Dim copyNumber As Long: copyNumber = 0
    
    Do While FileListView.ExistsInList(tempName)
    
        copyNumber = copyNumber + 1
        tempName = itemName & "_copy" & copyNumber
    
    Loop
    
    GetCopyName = tempName

End Function

'
'   move selected to Trash Bin
'
Private Sub MoveToTrash()

    If Not FormSingleProblem.TestCurrentForSave Then Exit Sub

    If mflvRepository.Items.Count < 1 Then Exit Sub
    
    Dim sourceFile As String, targetFile As String
    Dim tempAnalysisRow As Long
    Dim tempSourceItem As ListItem, tempTargetItem As ListItem
    Dim newTargetName As String
    
    For Each tempSourceItem In mflvRepository.Items
    
        If tempSourceItem.Selected Then
        
            newTargetName = GetCopyName(tempSourceItem.Text, mflvTrash)
        
            sourceFile = RepositoryFolder & "\" & tempSourceItem.Text & ".txt"
            targetFile = TrashFolder & "\" & newTargetName & ".txt"
            If Dir(sourceFile) <> "" Then Name sourceFile As targetFile
        
            '   check for result detail files
            sourceFile = RepositoryFolder & "\Solutions\" & tempSourceItem.Text & DetailFileExtension(PushPull)
            targetFile = TrashFolder & "\Solutions\" & newTargetName & DetailFileExtension(PushPull)
            If Dir(sourceFile) <> "" Then
                Name sourceFile As targetFile
            Else
            
                FormSingleProblem.CurrentProblem.ProblemSaved = True
            End If
            
            sourceFile = RepositoryFolder & "\Solutions\" & tempSourceItem.Text & DetailFileExtension(Simplex)
            targetFile = TrashFolder & "\Solutions\" & newTargetName & DetailFileExtension(Simplex)
            If Dir(sourceFile) <> "" Then Name sourceFile As targetFile
        
            Set tempTargetItem = mflvTrash.AddItem(tempSourceItem)
            tempTargetItem.Text = newTargetName
            tempTargetItem.Selected = True
            tempTargetItem.EnsureVisible
        
            With FormAnalysis
            
                If .ProblemAnalysisRow(tempSourceItem.Text) > 0 Then
            
                    Set .SelectedProblem = .ProblemInCollection(tempSourceItem.Text)
                    .RemoveSelectedProblem
                
                End If
                
            End With
            
        End If
    
    Next tempSourceItem

    mflvRepository.RemoveSelected
    
    If mflvRepository.Items.Count > 0 Then
    
        mflvRepository.Locate mflvRepository.FirstItem.Text, True
        
    Else
    
        FormSingleProblem.EmptyForm
    
    End If
    

End Sub

'
'   restore from Trash Bin
'
Private Sub RestoreFromTrash()

    If Not FormSingleProblem.TestCurrentForSave Then Exit Sub

    If mflvTrash.Items.Count < 1 Then Exit Sub

    Dim sourceFile As String, targetFile As String

    Dim tempSourceItem As ListItem, tempTargetItem As ListItem
    
    Dim newTargetName As String
    
    For Each tempSourceItem In mflvTrash.Items
    
        If tempSourceItem.Selected Then
        
            newTargetName = GetCopyName(tempSourceItem.Text, mflvRepository)
        
            targetFile = RepositoryFolder & "\" & newTargetName & ".txt"
            sourceFile = TrashFolder & "\" & tempSourceItem.Text & ".txt"
            Name sourceFile As targetFile
        
            '   check for result detail files
            targetFile = RepositoryFolder & "\Solutions\" & newTargetName & DetailFileExtension(PushPull)
            sourceFile = TrashFolder & "\Solutions\" & tempSourceItem.Text & DetailFileExtension(PushPull)
            If Dir(sourceFile) <> "" Then Name sourceFile As targetFile
            
            targetFile = RepositoryFolder & "\Solutions\" & newTargetName & DetailFileExtension(Simplex)
            sourceFile = TrashFolder & "\Solutions\" & tempSourceItem.Text & DetailFileExtension(Simplex)
            If Dir(sourceFile) <> "" Then Name sourceFile As targetFile
        
            Set tempTargetItem = mflvRepository.AddItem(tempSourceItem)
            tempTargetItem.Text = newTargetName
            tempTargetItem.Selected = True
            tempTargetItem.EnsureVisible
        
        End If
    
    Next tempSourceItem

    If Not tempTargetItem Is Nothing Then _
        mflvRepository.Locate tempTargetItem.Text, True
    
    mflvTrash.RemoveSelected
        
End Sub


'
'   basic form on-load settings
'
Private Sub SetFormUp()

    Set malAction.HostForm1 = FormAnalysis
    Set malAction.HostForm2 = FormRepository
    Set malAction.HostForm3 = FormSingleProblem
    With malAction
        .Move 0, 0
        .AddNew "NEW", "Create New", "Create a new problem with default values."
        .AddNew "RENAME", "Rename Problem", "Rename selected problem and all of its files."
        .AddNew "COPY", "Create a Duplicate", "Create a duplicate of selected problem."
        .AddNew "INCLUDE", "Add to Analysis", "Include selected problems in current analysis."
        .AddNew "MOVE", "Move to Trash", "Move selected problems to trash bin."
        .AddNew "RESTORE", "Restore from Trash", "Restore selected problems from trash bin."
        .AddNew "EMPTY", "Empty Trash", "Permanently deliting problems in trash bin."
    End With

    With mflvTrash
        .Move malAction.Width, 0, 1000, malAction.Height
        .Folder = TrashFolder
        .Caption = "Trash Bin"
        .Refresh
        SignificantWidth = .Left + .LabelRightEdge
    End With
    
    With mflvRepository
        .Move 0, malAction.Height
        .Folder = RepositoryFolder
        .Caption = "Problems Repository"
        .CanEdit = True
        .Refresh
    End With
    
End Sub

'
'   activating the form
'
Private Sub Form_Activate()

    If firstActivation Then
    
        firstActivation = False
    
        FormSingleProblem.EmptyForm
        
        If mflvRepository.SelectedItem <> "" Then
        
            FormSingleProblem.CurrentProblem.ProblemSaved = True
            FormSingleProblem.OpenProblem mflvRepository.SelectedItem
        
        End If
    
    End If
    
End Sub

'
'   loading of the form
'
Private Sub Form_Load()

    IsNewProblem = False
    firstActivation = True
    SetFormUp

End Sub

'
'   on query unload
'
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    Cancel = 1
    
    Me.WindowState = 1

End Sub

'
'   form resize
'
Private Sub Form_Resize()

    If Me.WindowState <> 1 And FormMain.WindowState <> 1 Then
    
        With mflvRepository
            .Resize Me.ScaleWidth - .Left, Me.ScaleHeight - .Top
        End With
    
        With mflvTrash
            .Resize Me.ScaleWidth - .Left
        End With
    
    End If

End Sub

'
'   action selected
'
Private Sub malAction_Action(ActionName As String)

    Select Case ActionName
    
    Case "NEW": CreateNewProblem
    
    Case "RENAME": mflvRepository.StartEditing
    
    Case "COPY": CreateCopy
    
    Case "INCLUDE": ExecuteIncludeProblems
    
    Case "MOVE": MoveToTrash
    
    Case "RESTORE": RestoreFromTrash
    
    Case "EMPTY": EmptyTrashBin
    
    Case Else: MsgBox (ActionName)
    
    End Select

End Sub


'
'   item was clicked
'
Private Sub mflvRepository_ItemClicked(itemName As String)
        
    If Not FormAnalysis.ShowSelected(itemName) Then _
        FormSingleProblem.OpenProblem itemName

End Sub



Private Sub mflvRepository_LostFocus()

    With mflvRepository
    
        If .BeingEdited Then .ForceProcessEditing
    
    End With

End Sub

'
'   renaming file(s)
'
Private Sub mflvRepository_NameChanged(canceled As Boolean, editedItem As MSComctlLib.ListItem, newName As String)

On Error GoTo errorNameChanged

    '   check if new name is correct
    If Not canceled Then
        
        '   problem with that name already exists
        If mflvRepository.ExistsInList(newName) Then _
            Err.Raise errorNumberBadData, , "Problem with that name already exists!"
        
        '   empty name
        If Trim(newName) = "" Then _
            Err.Raise errorNumberBadData, , "Problem's name can't be empty!"
        
        '   try to create a file (checking for valid file name)
        Open App.Path & "\" & newName & ".tmp" For Output As #1
        Close #1
        Kill App.Path & "\" & newName & ".tmp"
        
    End If
    
'    If IsNewProblem Then
'        '   new problem
'        If canceled Then
'            '   name change canceled
'            mflvRepository.RemoveItem editedItem
'
'        Else
'
'            If Not FormSingleProblem.NewProblem(newName) Then
'                '   new problem method failed
'                mflvRepository.RemoveItem editedItem
'                Exit Sub
'
'            End If
'
'            editedItem.Text = newName
'
'            mflvRepository.ReArrange
'
'            FormSingleProblem.SetFocus
'            FormSingleProblem.EditGlobalDataStart "S"
'
'        End If
'
'    Else
        '   rename files and problem name
        If Not canceled Then
            
            Dim sourceFile As String, targetFile As String
            Dim oldProblemName As String: oldProblemName = editedItem.Text
            
            With FormSingleProblem.CurrentProblem
            
                '   rename definition file
                sourceFile = .Definition.DefinitionFile
                targetFile = .Definition.DefinitionFile(returnFilePath) & newName & ".txt"
                If Dir(sourceFile) <> "" Then Name sourceFile As targetFile
            
                '   rename push and pull detail file
                sourceFile = .Result(PushPull).DetailFile
                targetFile = .Result(PushPull).DetailFile(returnFilePath) & newName & DetailFileExtension(PushPull)
                If Dir(sourceFile) <> "" Then
                    Name sourceFile As targetFile
                    .Result(PushPull).DetailFile = targetFile
                End If
                
                '   rename simplex detail file
                sourceFile = .Result(Simplex).DetailFile
                targetFile = .Result(Simplex).DetailFile(returnFilePath) & newName & DetailFileExtension(Simplex)
                If Dir(sourceFile) <> "" Then
                    Name sourceFile As targetFile
                    .Result(Simplex).DetailFile = targetFile
                End If
            
                '   save detail file
                .SaveProblem .Definition.DefinitionFile(returnFilePath) & newName & ".txt"
                .Result(PushPull).ShowResult
                .Result(Simplex).ShowResult
                
            End With
            
            '   edit analysis list if necessary
            FormAnalysis.ChangeProblemData editedItem.Text, newName
            
            editedItem.Text = newName
        
            mflvRepository.ReArrange
            
            mflvRepository.Locate newName
        
        End If
    
'    End If
    
    If IsNewProblem Then
        '   new problem
        
        FormSingleProblem.SetFocus
        FormSingleProblem.EditGlobalDataStart "S"
   
    End If
    
    IsNewProblem = False

    Exit Sub
    
errorNameChanged:

    MsgBox "Problem can not have that name: '" & newName & "'!" & _
            NewLine(Err.Description), , "RENAMING PROBLEM!"
            
    mflvRepository.StartEditing

End Sub


