VERSION 5.00
Begin VB.UserControl MyActiveLabels 
   ClientHeight    =   1020
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1365
   ScaleHeight     =   1020
   ScaleWidth      =   1365
   Begin VB.Label ActionLabels 
      AutoSize        =   -1  'True
      Caption         =   "Action"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   525
   End
End
Attribute VB_Name = "MyActiveLabels"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'   USER CONTROL: ACTION LABELS - ACT AS COMMAND BUTTONS

Option Explicit

Private Const buffMargin As Long = 100

Public Enum ActiveLabelsDirection
    
    alVertical
    alHorizontal
    
End Enum

Public Direction As ActiveLabelsDirection
                 
Public WithEvents HostForm1 As Form
Attribute HostForm1.VB_VarHelpID = -1
Public WithEvents HostForm2 As Form
Attribute HostForm2.VB_VarHelpID = -1
Public WithEvents HostForm3 As Form
Attribute HostForm3.VB_VarHelpID = -1
                 
Private Type FieldsType

    SelectedLabel As Label

    FirstLabelInitiated As Boolean

End Type

Private fields As FieldsType
                  
Public Event Action(ActionName As String)
                  
'
'   enable all labels
'
Public Sub EnableAll(newValue As Boolean)

    Dim tempLabel As Label
    For Each tempLabel In ActionLabels
    
        tempLabel.Enabled = newValue

    Next tempLabel

End Sub


'
'   Property Let FirstLabelInitiated
'
Private Property Let FirstLabelInitiated(newValue As Boolean)
    
    If newValue = False Then
    
        fields.FirstLabelInitiated = False
        Exit Property
        
    End If
    
    If fields.FirstLabelInitiated Then
    
        Load ActionLabels(ActionLabels.Count)
    
    Else
    
        fields.FirstLabelInitiated = True
    
    End If

End Property

'
'   find label based on its name
'
Private Function FindLabel(labelName As String) As Label

    Set FindLabel = Nothing
    
    Dim tempLabel As Label
    For Each tempLabel In ActionLabels
    
        If tempLabel.Tag = labelName Then
        
            Set FindLabel = tempLabel
            Exit Function
    
        End If
        
    Next tempLabel

End Function

'
'   property let LabelEnabled
'
Public Property Let LabelEnabled(Optional labelName As String = "", _
                                 newValue As Boolean)
    
    Dim tempLabel As Label
    Set tempLabel = FindLabel(labelName)
    If tempLabel Is Nothing Then Set tempLabel = SelectedLabel
    If tempLabel Is Nothing Then Exit Property
    
    tempLabel.Enabled = newValue

End Property

'
'   property get LabelEnabled
'
Public Property Get LabelEnabled(Optional labelName As String = "") As Boolean
    
    Dim tempLabel As Label
    Set tempLabel = FindLabel(labelName)
    If tempLabel Is Nothing Then Set tempLabel = SelectedLabel
    If tempLabel Is Nothing Then Exit Property
    
    LabelEnabled = tempLabel.Enabled

End Property

'
'   property let CheckLabel
'
Public Property Let CheckLabel(Optional labelName As String = "", _
                               newValue As Boolean)
    
    Dim checkString As String
    checkString = IIf(newValue, "x ", "  ")
    
    Dim tempLabel As Label
    Set tempLabel = FindLabel(labelName)
    If tempLabel Is Nothing Then Set tempLabel = SelectedLabel
    If tempLabel Is Nothing Then Exit Property
    
    tempLabel.Caption = checkString & Mid(SelectedLabel.Caption, 3)

End Property

'
'   property get CheckLabel
'
Public Property Get CheckLabel(Optional labelName As String = "") As Boolean
    
    CheckLabel = False
    
    Dim tempLabel As Label
    Set tempLabel = FindLabel(labelName)
    If tempLabel Is Nothing Then Set tempLabel = SelectedLabel
    If tempLabel Is Nothing Then Exit Property
    
    CheckLabel = (Left(tempLabel.Caption, 1) = "x")

End Property

'
'   add a new action label
'
Public Sub AddNew(newName As String, _
                  newCaption As String, _
                  newToolTipText As String, _
                  Optional newEnabled As Boolean = True, _
                  Optional Checked As Boolean = False, _
                  Optional CheckValue As Boolean = False)
                  
    FirstLabelInitiated = True
    
    Set SelectedLabel = ActionLabels(ActionLabels.Count - 1)
    
    With ActionLabels(ActionLabels.Count - 1)
    
        .Tag = newName
        
        If Not Checked Then
            .Caption = newCaption
        Else
            .Caption = "  " & newCaption
            CheckLabel = CheckValue
        End If
        
        .AutoSize = True
        .ToolTipText = newToolTipText
        .Enabled = newEnabled
            
        If .Index > 0 Then
            
            If Direction = alVertical Then
                .Top = ActionLabels(.Index - 1).Top + ActionLabels(.Index - 1).Height + buffMargin
            Else
                .Left = ActionLabels(.Index - 1).Left + ActionLabels(.Index - 1).Width + 3 * buffMargin
            End If
        
        Else
        
            .Top = 2 * buffMargin
            .Left = 2 * buffMargin
        
        End If
    
        .AutoSize = True
        .Visible = True
        
    End With
    
    Set SelectedLabel = Nothing
                  
    '   apply proper redimension
    With UserControl
        
        .Height = 4 * buffMargin
        .Width = 4 * buffMargin
        
        Dim tempLabel As Label
        For Each tempLabel In ActionLabels
                    
            If .Width < 2 * buffMargin + tempLabel.Left + tempLabel.Width Then _
                .Width = 2 * buffMargin + tempLabel.Left + tempLabel.Width
    
            If .Height < 2 * buffMargin + tempLabel.Top + tempLabel.Height Then _
                .Height = 2 * buffMargin + tempLabel.Top + tempLabel.Height
    
        Next tempLabel
        
    End With
                  
End Sub

'
'   action label clicked
'
Private Sub ActionLabels_Click(Index As Integer)

    RaiseEvent Action(ActionLabels(Index).Tag)

    Set SelectedLabel = Nothing

End Sub

'
'   moving mouse over the label
'
Private Sub ActionLabels_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

    Set SelectedLabel = Nothing
    Set SelectedLabel = ActionLabels(Index)

End Sub

'   Mouse moved on the host form
Private Sub HostForm1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If fields.SelectedLabel Is Nothing Then Exit Sub

    fields.SelectedLabel.Font.Underline = True
    fields.SelectedLabel.Font.Bold = True
    fields.SelectedLabel.ForeColor = RGB(0, 0, 155)

End Sub
Private Sub HostForm2_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If fields.SelectedLabel Is Nothing Then Exit Sub

    fields.SelectedLabel.Font.Underline = True
    fields.SelectedLabel.Font.Bold = True
    fields.SelectedLabel.ForeColor = RGB(0, 0, 155)

End Sub
Private Sub HostForm3_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If fields.SelectedLabel Is Nothing Then Exit Sub

    fields.SelectedLabel.Font.Underline = True
    fields.SelectedLabel.Font.Bold = True
    fields.SelectedLabel.ForeColor = RGB(0, 0, 155)

End Sub


'
'   Initialization of control
'
Private Sub UserControl_Initialize()

    Direction = alVertical
    FirstLabelInitiated = False

End Sub

'
'   moving mouse not over any label
'
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Set SelectedLabel = Nothing

End Sub

'
'   property get SelectedLabel
'
Public Property Get SelectedLabel() As Label

    Set SelectedLabel = fields.SelectedLabel

End Property

'
'   property Set Selected label
'
Public Property Set SelectedLabel(newLabel As Label)

    If Not newLabel Is Nothing Then
    
        newLabel.ForeColor = RGB(0, 0, 255)
        newLabel.Font.Underline = True
        newLabel.Font.Bold = True
        
    Else
    
        If fields.SelectedLabel Is Nothing Then Exit Property
    
        fields.SelectedLabel.Font.Underline = True
        fields.SelectedLabel.Font.Bold = True
        fields.SelectedLabel.ForeColor = RGB(0, 0, 155)
                
    End If
    
    Set fields.SelectedLabel = newLabel

End Property
