VERSION 5.00
Begin VB.UserControl MyCheckLabels 
   ClientHeight    =   960
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1395
   ScaleHeight     =   960
   ScaleWidth      =   1395
   Begin VB.Label CheckLabels 
      Alignment       =   2  'Center
      BackColor       =   &H80000018&
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   9
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Index           =   0
      Left            =   300
      TabIndex        =   1
      Top             =   180
      Width           =   210
   End
   Begin VB.Label ActionLabels 
      AutoSize        =   -1  'True
      Caption         =   "Action"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   210
      Index           =   0
      Left            =   540
      TabIndex        =   0
      Top             =   180
      Width           =   465
   End
End
Attribute VB_Name = "MyCheckLabels"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


'   USER CONTROL: CHECK LABELS - ACT AS CHECK BOXES

Private Const buffMargin As Long = 50

Private Type FieldsType

    SelectedLabel As Label

    FirstLabelInitiated As Boolean

End Type

Private fields As FieldsType
                  
Public WithEvents HostForm1 As Form
Attribute HostForm1.VB_VarHelpID = -1
Public WithEvents HostForm2 As Form
Attribute HostForm2.VB_VarHelpID = -1
Public WithEvents HostForm3 As Form
Attribute HostForm3.VB_VarHelpID = -1


'
'   enable all labels
'
Public Sub EnableAll(newValue As Boolean)

    Dim tempLabel As Label
    For Each tempLabel In ActionLabels
    
        tempLabel.Enabled = newValue

    Next tempLabel

End Sub

'
'   Property Let FirstLabelInitiated
'
Private Property Let FirstLabelInitiated(newValue As Boolean)
    
    If newValue = False Then
    
        fields.FirstLabelInitiated = False
        Exit Property
        
    End If
    
    If fields.FirstLabelInitiated Then
    
        Load CheckLabels(CheckLabels.Count)
        Load ActionLabels(ActionLabels.Count)
    
    Else
    
        fields.FirstLabelInitiated = True
    
    End If

End Property

'
'   find label based on its name
'
Private Function FindLabel(labelName As String) As Label

    Set FindLabel = Nothing
    
    Dim tempLabel As Label
    For Each tempLabel In ActionLabels
    
        If tempLabel.Tag = labelName Then
        
            Set FindLabel = tempLabel
            Exit Function
    
        End If
        
    Next tempLabel

End Function

'
'   property let LabelEnabled
'
Public Property Let LabelEnabled(Optional labelName As String = "", _
                                 newValue As Boolean)
    
    Dim tempLabel As Label
    Set tempLabel = FindLabel(labelName)
    If tempLabel Is Nothing Then Set tempLabel = SelectedLabel
    If tempLabel Is Nothing Then Exit Property
    
    tempLabel.Enabled = newValue
    CheckLabels(tempLabel.Index).Enabled = newValue

End Property

'
'   property get LabelEnabled
'
Public Property Get LabelEnabled(Optional labelName As String = "") As Boolean
    
    Dim tempLabel As Label
    Set tempLabel = FindLabel(labelName)
    If tempLabel Is Nothing Then Set tempLabel = SelectedLabel
    If tempLabel Is Nothing Then Exit Property
    
    LabelEnabled = tempLabel.Enabled

End Property

'
'   property let CheckLabel
'
Public Property Let CheckLabel(Optional labelName As String = "", _
                               newValue As Boolean)
    
    Dim checkString As String
    checkString = IIf(newValue, "", " ")
    
    Dim tempLabel As Label
    Set tempLabel = FindLabel(labelName)
    If tempLabel Is Nothing Then Set tempLabel = SelectedLabel
    If tempLabel Is Nothing Then Exit Property
    
    CheckLabels(tempLabel.Index).Caption = checkString

End Property

'
'   property get CheckLabel
'
Public Property Get CheckLabel(Optional labelName As String = "") As Boolean
    
    CheckLabel = False
    
    Dim tempLabel As Label
    Set tempLabel = FindLabel(labelName)
    If tempLabel Is Nothing Then Set tempLabel = SelectedLabel
    If tempLabel Is Nothing Then Exit Property
    
    CheckLabel = (CheckLabels(tempLabel.Index) = "")

End Property

'
'   add a new action label
'
Public Sub AddNew(newName As String, _
                  newCaption As String, _
                  newToolTipText As String, _
                  Optional newEnabled As Boolean = True, _
                  Optional Checked As Boolean = True)
                  
    
    FirstLabelInitiated = True
    
    Set SelectedLabel = ActionLabels(ActionLabels.Count - 1)
    
    Dim tempChecked As Label: Set tempChecked = CheckLabels(SelectedLabel.Index)
    
    
    With SelectedLabel
    
        .Tag = newName
        .Caption = newCaption
        CheckLabel = Checked
        .AutoSize = True
        .ToolTipText = newToolTipText
        tempChecked.ToolTipText = newToolTipText
        .Enabled = newEnabled
        tempChecked.Enabled = newEnabled
        
        If .Index > 0 Then
            
            .Top = ActionLabels(.Index - 1).Top + ActionLabels(.Index - 1).Height + buffMargin
            tempChecked.Top = .Top
        
        Else
        
            .Top = buffMargin
            tempChecked.Top = .Top
            tempChecked.Left = 2 * buffMargin
            .Left = tempChecked.Left + tempChecked.Width + buffMargin
            
        End If
    
        .AutoSize = False
        .Visible = True
        tempChecked.Visible = True
        
    End With
    
    Set SelectedLabel = Nothing
                  
    '   apply proper redimension
    With UserControl
        
        .Height = 2 * buffMargin
        .Width = 2 * buffMargin
        
        Dim tempLabel As Label
        For Each tempLabel In ActionLabels
                    
            If .Width < 4 * buffMargin + tempLabel.Left + tempLabel.Width Then _
                .Width = 4 * buffMargin + tempLabel.Left + tempLabel.Width
    
            If .Height < 2 * buffMargin + tempLabel.Top + tempLabel.Height Then _
                .Height = 2 * buffMargin + tempLabel.Top + tempLabel.Height
    
        Next tempLabel
        
    End With
                  
End Sub

'
'   action label clicked
'
Private Sub ActionLabels_Click(Index As Integer)

    CheckLabel = Not CheckLabel
    
    Set SelectedLabel = Nothing

End Sub

'
'   Check label clicked
'
Private Sub CheckLabels_Click(Index As Integer)

    ActionLabels_Click Index
    
End Sub

'
'   moving mouse over the label
'
Private Sub ActionLabels_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

    Set SelectedLabel = Nothing
    Set SelectedLabel = ActionLabels(Index)

End Sub

'
'   moving mouse over the check label
'
Private Sub CheckLabels_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

    ActionLabels_MouseMove Index, Button, Shift, X, Y

End Sub

'
'   mouse moved on the host form
'
Private Sub HostForm1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If fields.SelectedLabel Is Nothing Then Exit Sub
    
'    fields.SelectedLabel.Font.Underline = True
'    fields.SelectedLabel.Font.Bold = True
    fields.SelectedLabel.ForeColor = RGB(0, 0, 155)

End Sub
Private Sub HostForm2_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If fields.SelectedLabel Is Nothing Then Exit Sub
    
'    fields.SelectedLabel.Font.Underline = True
'    fields.SelectedLabel.Font.Bold = True
    fields.SelectedLabel.ForeColor = RGB(0, 0, 155)

End Sub
Private Sub HostForm3_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If fields.SelectedLabel Is Nothing Then Exit Sub
    
'    fields.SelectedLabel.Font.Underline = True
'    fields.SelectedLabel.Font.Bold = True
    fields.SelectedLabel.ForeColor = RGB(0, 0, 155)

End Sub

'
'   Initialization of control
'
Private Sub UserControl_Initialize()

    FirstLabelInitiated = False

End Sub

'
'   moving mouse not over any label
'
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Set SelectedLabel = Nothing

End Sub

'
'   property get SelectedLabel
'
Public Property Get SelectedLabel() As Label

    Set SelectedLabel = fields.SelectedLabel

End Property

'
'   property Set Selected label
'
Public Property Set SelectedLabel(newLabel As Label)

    If Not newLabel Is Nothing Then
    
        newLabel.ForeColor = RGB(0, 0, 255)
'        newLabel.Font.Underline = True
        
    Else
    
        If fields.SelectedLabel Is Nothing Then Exit Property
    
'        fields.SelectedLabel.Font.Underline = True
        fields.SelectedLabel.ForeColor = RGB(0, 0, 155)
        
    End If
    
    Set fields.SelectedLabel = newLabel

End Property


