VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.UserControl MyFileListView 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.TextBox TextEdit 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      Height          =   285
      Left            =   2940
      TabIndex        =   2
      Text            =   "Text1"
      Top             =   3240
      Visible         =   0   'False
      Width           =   1035
   End
   Begin MSComctlLib.ListView HostListView 
      Height          =   2955
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   4155
      _ExtentX        =   7329
      _ExtentY        =   5212
      View            =   2
      Arrange         =   1
      LabelEdit       =   1
      Sorted          =   -1  'True
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483624
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   0
   End
   Begin VB.Label LabelCaption 
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   795
   End
End
Attribute VB_Name = "MyFileListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const buffMargin As Long = 150

Private Type FieldsType

    Folder As String
    LabelRightEdge As Long
    
    currentItem As ListItem
    
    CanEdit As Boolean
    editCanceled As Boolean
    editedItem As ListItem
    
    BeingEdited As Boolean
    
End Type

Private fields As FieldsType

Public Event ItemClicked(itemName As String)

Public Event NameChanged(canceled As Boolean, editedItem As ListItem, newName As String)



'
'   add new item as listitem to list view
'
Public Function AddItem(newItem As ListItem) As ListItem

    Set AddItem = HostListView.ListItems.Add(, , newItem.Text)

End Function


'
'   property get BeingEdited
'
Public Property Get BeingEdited() As Boolean

    BeingEdited = fields.BeingEdited

End Property

'
'   return first item in list
'
Public Function FirstItem() As ListItem

    Set FirstItem = HostListView.ListItems(1)

End Function

'
'   return items collection
'
Public Property Get Items() As ListItems

    Set Items = HostListView.ListItems

End Property

'
'   try to locate item by name
'
Public Sub Locate(itemName As String, _
                  Optional WithOpen As Boolean = False)
    
    DeselectAll
    
    With HostListView

        Set .SelectedItem = .FindItem(itemName)
        Set fields.currentItem = .SelectedItem
        
    End With

    If WithOpen Then RaiseEvent ItemClicked(fields.currentItem.Text)

End Sub

'
'   check if item exists
'
Public Function ExistsInList(itemName As String) As Boolean
    
    Dim tempItem As ListItem: Set tempItem = HostListView.FindItem(itemName)
    
    ExistsInList = (Not tempItem Is Nothing)

End Function


'
'   try to find item by name
'
Public Function ItemByName(itemName As String) As ListItem

    Set ItemByName = HostListView.FindItem(itemName)

End Function


'
'   rearrange sorted
'
Public Sub ReArrange()

    HostListView.Refresh
    HostListView.Sorted = True


End Sub

'
'   remove item
'
Public Sub RemoveItem(item As ListItem)

    HostListView.ListItems.Remove item.Index

    Set fields.currentItem = Nothing

End Sub

'
'   deselect all tems
'
Private Sub DeselectAll()
        
    Dim tempItem As ListItem
    For Each tempItem In HostListView.ListItems
        
        tempItem.Selected = False
        
    Next tempItem
    
    Set HostListView.SelectedItem = Nothing

End Sub


'
'   add temporary item
'
Public Sub AddNewTemporary(defaultName As String)

    With HostListView
    
        DeselectAll
        
        Set fields.currentItem = HostListView.ListItems.Add(, , defaultName)
        '.SetFocus
        Set .SelectedItem = fields.currentItem
        .Refresh
        
    End With
    
    StartEditing
    
End Sub

'
'   property get label right edge
'
Public Property Get LabelRightEdge() As Long

    LabelRightEdge = LabelCaption.Left + LabelCaption.Width + 3 * buffMargin

End Property

'
'   property get Folder
'
Public Property Get Folder() As String

    Folder = fields.Folder

End Property

'
'   property let Folder
'
Public Property Let Folder(newFolder As String)

    fields.Folder = newFolder

End Property

'
'   define caption
'
Public Property Get Caption() As String

    Caption = LabelCaption.Caption

End Property

'
'   define caption
'
Public Property Let Caption(newValue As String)

    LabelCaption.Caption = newValue

    LabelCaption.AutoSize = True
    
End Property

'
'   refresh files in the folder
'
Public Sub Refresh()

    HostListView.ListItems.Clear
    
    Dim tempFile As String
    
    tempFile = Dir(Folder & "\*.txt")
    Do While tempFile <> ""
    
        HostListView.ListItems.Add , , ModuleUtilities.ReturnFileAs(tempFile, returnNameInFile)
        
        tempFile = Dir()
    Loop

End Sub

'
'   remove selected items
'
Public Sub RemoveSelected()

    Dim i As Long
    
    i = HostListView.ListItems.Count
    
    Do While i > 0
    
        If HostListView.ListItems(i).Selected Then HostListView.ListItems.Remove i
        
        i = i - 1
    
    Loop
    
End Sub


'
'   resizing of user control
'
Public Sub Resize(Optional newWidth As Long = -1, _
                  Optional newHeight As Long = -1)
                  
    If newWidth > 2 * buffMargin Then _
        UserControl.Width = newWidth
    
    If newHeight > (LabelCaption.Top + LabelCaption.Height + buffMargin) Then _
        UserControl.Height = newHeight

End Sub

'
'   property get selected item
'
Public Property Get SelectedItem() As String

    If HostListView.SelectedItem Is Nothing Then
    
        SelectedItem = ""
        
    Else
    
        SelectedItem = HostListView.SelectedItem.Text

    End If
    
End Property

'
'
'
Private Sub HostListView_KeyUp(KeyCode As Integer, Shift As Integer)

    If Shift > 0 Then Exit Sub
    
'    If Switch(KeyCode = 16, 1, KeyCode = 17, 1, KeyCode = 27, 1, KeyCode = 13, 1) = 1 Then Exit Sub
    
    Select Case KeyCode
    
        Case 37, 38, 39, 40
    
            If Not HostListView.SelectedItem Is Nothing Then
    
                HostListView_MouseUp 0, 0, _
                    HostListView.SelectedItem.Left + 50, _
                    HostListView.SelectedItem.Top + 50
            
            End If
        
    End Select

End Sub

'
'   mouse down
'
Private Sub HostListView_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    Set HostListView.SelectedItem = Nothing

End Sub

'
'   mouse up: open problem
'
Private Sub HostListView_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

    If Shift <> 0 Then Exit Sub
    
    Dim tempItem As ListItem
    
    Set tempItem = fields.currentItem
    
    Set fields.currentItem = HostListView.HitTest(x, y)
    
    If fields.currentItem Is Nothing Then Exit Sub
        
    If tempItem Is Nothing Then
        '   no item was selected before this
        RaiseEvent ItemClicked(fields.currentItem.Text)
        Exit Sub
    
    End If
        
    If tempItem.Text <> fields.currentItem.Text Then
        '   open problem
        RaiseEvent ItemClicked(fields.currentItem.Text)
    
    Else
        '   rename problem
        StartEditing
        
    End If
    
End Sub

'
'   initialization of an user control
'
Private Sub UserControl_Initialize()

    Folder = ""
    fields.CanEdit = False
    
End Sub

'
'   property let names can be edited
'
Public Property Let CanEdit(newValue As Boolean)

    fields.CanEdit = newValue

End Property

'
'   user control resizing
'
Private Sub UserControl_Resize()
    
    LabelCaption.Move UserControl.ScaleLeft + buffMargin, _
                      UserControl.ScaleTop + 2 * buffMargin
    
    HostListView.Move UserControl.ScaleLeft + buffMargin, _
                      LabelCaption.Top + LabelCaption.Height + 50, _
                      UserControl.ScaleWidth - 2 * buffMargin, _
                      UserControl.ScaleHeight - LabelCaption.Top - LabelCaption.Height - buffMargin

End Sub


'
'   edit file name
'
Public Sub StartEditing()

    If Not fields.CanEdit Then Exit Sub

    If fields.currentItem Is Nothing Then Exit Sub
    
    Set fields.editedItem = fields.currentItem

    With fields.currentItem
    
        fields.BeingEdited = True
        
        Set TextEdit.Font = HostListView.Font
    
        TextEdit.Move HostListView.Left + .Left, _
                      HostListView.Top + .Top, _
                      .Width, .Height
        TextEdit.Text = .Text
        TextEdit.SelStart = 0
        TextEdit.SelLength = Len(.Text)
        
        TextEdit.Visible = True
        
        TextEdit.SetFocus
        
    End With

End Sub

'
'   leaving edit text box
'
Private Sub TextEdit_LostFocus()

    TextEdit.Visible = False
    ProcessEditing

End Sub

'
'   key pressed on edit text box
'
Private Sub TextEdit_KeyPress(KeyAscii As Integer)

    If KeyAscii = 13 Then
        '   ENTER
        TextEdit.Visible = False
        KeyAscii = 0
        
    End If

    If KeyAscii = 27 Then
        '   ESC
        fields.editCanceled = True
        TextEdit.Visible = False
        KeyAscii = 0
        
    End If

End Sub

'
'   actually process editing
'
Private Sub ProcessEditing()

    fields.BeingEdited = False

    If Not fields.editCanceled Then _
        fields.editCanceled = (UCase(fields.editedItem.Text) = UCase(TextEdit.Text))

    RaiseEvent NameChanged(fields.editCanceled, fields.editedItem, TextEdit.Text)
    fields.editCanceled = False

End Sub


Public Sub ForceProcessEditing()

    TextEdit.Visible = False
    ProcessEditing

End Sub
